# cloudfeaster

![Maintained](https://img.shields.io/maintenance/yes/2022.svg?style=flat)
![license](https://img.shields.io/pypi/l/cloudfeaster.svg?style=flat)
![PythonVersions](https://img.shields.io/pypi/pyversions/cloudfeaster.svg?style=flat)
![status](https://img.shields.io/pypi/status/cloudfeaster.svg?style=flat)
[![PyPI](https://img.shields.io/pypi/v/cloudfeaster.svg?style=flat)](https://pypi.python.org/pypi/cloudfeaster)
[![Requirements](https://requires.io/github/simonsdave/cloudfeaster/requirements.svg?branch=release-0.9.59)](https://requires.io/github/simonsdave/cloudfeaster/requirements/?branch=release-0.9.59)
[![CodeFactor](https://www.codefactor.io/repository/github/simonsdave/cloudfeaster/badge/release-0.9.59)](https://www.codefactor.io/repository/github/simonsdave/cloudfeaster/overview/release-0.9.59)
[![CircleCI](https://circleci.com/gh/simonsdave/cloudfeaster/tree/release-0.9.59.svg?style=shield)](https://circleci.com/gh/simonsdave/cloudfeaster/tree/release-0.9.59)
[![codecov](https://codecov.io/gh/simonsdave/cloudfeaster/branch/release-0.9.59/graph/badge.svg)](https://codecov.io/gh/simonsdave/cloudfeaster)
[![docker-simonsdave/cloudfeaster-dev-env](https://img.shields.io/badge/docker-simonsdave%2Fcloudfeaster--dev--env-blue.svg)](https://hub.docker.com/r/simonsdave/cloudfeaster-dev-env)
[![docker-simonsdave/cloudfeaster](https://img.shields.io/badge/docker-simonsdave%2Fcloudfeaster-blue.svg)](https://hub.docker.com/r/simonsdave/cloudfeaster)
[![docker-simonsdave/cloudfeaster-lite](https://img.shields.io/badge/docker-simonsdave%2Fcloudfeaster--lite-blue.svg)](https://hub.docker.com/r/simonsdave/cloudfeaster-lite)

Cloudfeaster is a web crawling and business process automation infrastructure that leverages
modern software engineering tools, services and trends to create:

* (this repo is) [a spider authoring and maintenance environment](https://github.com/simonsdave/cloudfeaster)
* a service infrastructure for discovering and running spiders via a RESTful API

[This](docs/story.md) is the story behind Cloudfeaster.

## What Next

* [this](docs/spider_authors.md) describes
  how to author spiders using Cloudfeaster
* see [these](docs/contributing.md) instructions
  describe how to setup your development environment and
  start contributing to Cloudfeaster
* take a look at [cloudfeaster/samples](cloudfeaster/samples/) for some
  spiders that illustrate the core concepts
* and [simonsdave/gaming-spiders](https://github.com/simonsdave/gaming-spiders) is an
  entire repo of spiders so you can get a sense of the end-to-end
